Loading...
Searching...
No Matches
pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType > Class Template Reference

Utility class for evaluating a fern. More...

`#include <pcl/ml/ferns/fern_evaluator.h>`

## Public Member Functions

| FernEvaluator ()
| Constructor.
void | evaluate (pcl::Fern< FeatureType, NodeType > &fern, pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > &feature_handler, pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > &stats_estimator, DataSet &data_set, std::vector< ExampleIndex > &examples, std::vector< LabelType > &label_data)
| Evaluates the specified examples using the supplied tree.
void | evaluateAndAdd (pcl::Fern< FeatureType, NodeType > &fern, pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > &feature_handler, pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > &stats_estimator, DataSet &data_set, std::vector< ExampleIndex > &examples, std::vector< LabelType > &label_data)
| Evaluates the specified examples using the supplied tree and adds the results to the supplied results array.
void | getNodes (pcl::Fern< FeatureType, NodeType > &fern, pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > &feature_handler, pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > &stats_estimator, DataSet &data_set, std::vector< ExampleIndex > &examples, std::vector< NodeType * > &nodes)
| Evaluates the specified examples using the supplied tree.

## Detailed Description

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>
class pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >

Utility class for evaluating a fern.

Definition at line 55 of file fern_evaluator.h.

## Constructor & Destructor Documentation

## FernEvaluator()

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>

pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::FernEvaluator | ( |  | ) |

Constructor.

Definition at line 54 of file fern_evaluator.hpp.

## Member Function Documentation

## evaluate()

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>

void pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluate | ( | pcl::Fern< FeatureType, NodeType > & | fern,
|  | pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > & | feature_handler,
|  | pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > & | stats_estimator,
|  | DataSet & | data_set,
|  | std::vector< ExampleIndex > & | examples,
|  | std::vector< LabelType > & | label_data )

Evaluates the specified examples using the supplied tree.

Parameters

  [in] | fern | the decision tree
  [in] | feature_handler | the feature handler used to train the tree
  [in] | stats_estimator | the statistics estimation instance used while training the tree
  [in] | data_set | the data set used for evaluation
  [in] | examples | the examples that have to be evaluated
  [out] | label_data | the destination for the resulting label data

Definition at line 63 of file fern_evaluator.hpp.

References pcl::Fern< FeatureType, NodeType >::accessFeature(), pcl::Fern< FeatureType, NodeType >::accessThreshold(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::computeBranchIndices(), pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::evaluateFeature(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::getLabelOfNode(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::getNumOfBranches(), and pcl::Fern< FeatureType, NodeType >::getNumOfFeatures().

## evaluateAndAdd()

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>

void pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::evaluateAndAdd | ( | pcl::Fern< FeatureType, NodeType > & | fern,
|  | pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > & | feature_handler,
|  | pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > & | stats_estimator,
|  | DataSet & | data_set,
|  | std::vector< ExampleIndex > & | examples,
|  | std::vector< LabelType > & | label_data )

Evaluates the specified examples using the supplied tree and adds the results to the supplied results array.

Parameters

  [in] | fern | the decision tree
  [in] | feature_handler | the feature handler used to train the tree
  [in] | stats_estimator | the statistics estimation instance used while training the tree
  [in] | data_set | the data set used for evaluation
  [in] | examples | the examples that have to be evaluated
  [out] | label_data | the destination where the resulting label data is added to

Definition at line 117 of file fern_evaluator.hpp.

References pcl::Fern< FeatureType, NodeType >::accessFeature(), pcl::Fern< FeatureType, NodeType >::accessThreshold(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::computeBranchIndices(), pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::evaluateFeature(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::getLabelOfNode(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::getNumOfBranches(), and pcl::Fern< FeatureType, NodeType >::getNumOfFeatures().

## getNodes()

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>

void pcl::FernEvaluator< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::getNodes | ( | pcl::Fern< FeatureType, NodeType > & | fern,
|  | pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > & | feature_handler,
|  | pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > & | stats_estimator,
|  | DataSet & | data_set,
|  | std::vector< ExampleIndex > & | examples,
|  | std::vector< NodeType * > & | nodes )

Evaluates the specified examples using the supplied tree.

Parameters

  [in] | fern | the decision tree
  [in] | feature_handler | the feature handler used to train the tree
  [in] | stats_estimator | the statistics estimation instance used while training the tree
  [in] | data_set | the data set used for evaluation
  [in] | examples | the examples that have to be evaluated
  [out] | nodes | the leaf-nodes reached while evaluation

Definition at line 169 of file fern_evaluator.hpp.

References pcl::Fern< FeatureType, NodeType >::accessFeature(), pcl::Fern< FeatureType, NodeType >::accessThreshold(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::computeBranchIndices(), pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex >::evaluateFeature(), pcl::StatsEstimator< LabelDataType, NodeType, DataSet, ExampleIndex >::getNumOfBranches(), and pcl::Fern< FeatureType, NodeType >::getNumOfFeatures().

The documentation for this class was generated from the following files:

- pcl/ml/ferns/fern_evaluator.h
- pcl/ml/impl/ferns/fern_evaluator.hpp